/******************************************************************************
 * Copyright 2020 The Firmament Authors. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *****************************************************************************/

#ifndef FIFO_H__
#define FIFO_H__

#include <stdint.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
	uint32_t size;
	uint32_t head;
	uint32_t cnt;
	float* data;
} FIFO;

uint8_t fifo_create(FIFO* fifo, uint16_t size);
void fifo_flush(FIFO* fifo);
void fifo_push(FIFO* fifo, float val);
float fifo_pop(FIFO* fifo);
float fifo_read_back(FIFO* fifo, uint16_t offset);

#ifdef __cplusplus
}
#endif

#endif
